import { Application } from 'express';
import { ClientOpts, RedisClient } from 'redis';
import * as ExpressBrute from 'express-brute';
import * as cors from 'cors';
import * as helmet from 'helmet';
import * as bodyParser from 'body-parser';
export declare function setBasicSecurity(app: Application, route: string, options?: SecurityOptions): void;
export declare function setBodyParser(app: Application, route: string, options?: BodyParserOptions): void;
export declare function getRateLimiter(options?: RateLimiterOptions): ExpressBrute;
export interface RateLimiterOptions extends ExpressBrute.Options {
    redis?: RedisOptions;
}
export interface SecurityOptions {
    cors?: cors.CorsOptions;
    helmet?: helmet.IHelmetConfiguration;
}
export interface BodyParserOptions {
    json?: bodyParser.OptionsJson;
    raw?: bodyParser.Options;
    text?: bodyParser.OptionsText;
    urlEncoded?: bodyParser.OptionsUrlencoded;
}
export interface RedisOptions extends ClientOpts {
    client?: RedisClient;
}
